#include <time.h>
#include "Algorytm.h"

void Err_(COLORREF kolor, HWND hwnd, char *tekst)
{
	HDC hdc;
	RECT r;
	
	//pobieram obszar klienta okna
	GetClientRect(GetDlgItem (hwnd, 1003), &r); 
	//pobieram kontekst urzdzenia
	hdc = GetDC(GetDlgItem (hwnd, 1003));
	
	//Kasuje poprzedni komunikat
	FillRect(hdc, &r, (HBRUSH) GetStockObject (LTGRAY_BRUSH));
    
	SetBkMode(hdc, TRANSPARENT); //ustawienie ta
	SetTextColor(hdc, kolor); //ustawienie koloru
	
	TextOut(hdc, 0, 0, tekst, static_cast<int>(strlen(tekst))); //wypisanie tekstu
	//zwalniam kontekst urzdzenia
	ReleaseDC(hwnd, hdc);
}

int zmienna[10];

//funkcja tab2int zamieniajaca tablice intow na zmienna typu int
int tab2int(int p)
{
	int i = 0, intek = 0;

	for(i = 0; i < p; i++)
	{
		intek *= 10;
		intek += zmienna[i]; 
	}
	return intek;
}



//funkcja zamien zamieniajaca znak ASCI char'a na wartosc inta
int zamien(int tmp)
{
int i;
	switch(tmp)
	{
	case '0':	i = 0;
				break;
	case '1':	i = 1;
				break;
	case '2':	i = 2;
				break;
	case '3':	i = 3;
				break;
	case '4':	i = 4;
				break;
	case '5':	i = 5;
				break;
	case '6':	i = 6;
				break;
	case '7':	i = 7;
				break;
	case '8':	i = 8;
				break;
	case '9':	i = 9;
				break;
	}
	return i;
}

//funkcja Odczyt pobierajaca dane z pliku, wyluskujaca potrzebne dane 
//i umieszczajaca je w strukturze. 
//Zwraca void

int Odczyt(const char *szFileName, PARAMETRY *dane, HWND hwnd)
{

int znak;
int BladOdczytu = 1;

long licznik = 1; //tutaj zliczamy cyfry odczytane z pliku
int i = 0, j = 0, a = 0, liczba = 0, p = 0, intek = 0, ujemna = 0; //zmienne pomocnicze
int f = 0;

FILE *plik;
plik = fopen(szFileName, "r");
	
//POCZATEK wczytywania danych z pliku
do
{
	znak = getc(plik);
	if((f == 1)&&(znak<48||znak>57))
	{
		f = 0;
	}
	if(znak == 120)
	{
		f = 1;
	}
	if(f == 1)
	{
		
	}
	else
	{
		if((znak>=48&&znak<=57)) //dopuszczalne jedynie cyfr
		{
			znak = zamien(znak);
			zmienna[p] = znak;
			p++;	
		}
		else //jezeli wczytany znak nie jest cyfra
		{

			if(p!=0) //jezeli w tablicy intow jest cos
			{
				intek = tab2int(p); //zamien tablice intow na zmienna typu int
				if(ujemna == 1) //jesli wczesniejszym znakiem byl minus
				{
					intek = (intek-(2*intek)); //zmienia na cyfre przeciwna
					ujemna = 0;
				}
				p = 0;
				if(licznik == 1) //jesli jest to pierwsza cyfra, zapisz ja do struktury jako N
				{
					if(intek>0)
						dane->N = intek;
					else
					{
						Err_(RGB(230, 0, 0), hwnd, "BD, Podaj liczbe zmiennych funkcji celu wieksza od zera!");
						PlaySound (("Media\\blad.wav"), NULL, SND_FILENAME | SND_ASYNC) ;
						fclose(plik); //zamkniecie pliku
						return 1;
					}

				}
				if(licznik == 2) //jesli jest to druga cyfra, zapisz ja do struktury jako M i zarezerwuj pamiec
				{
					if(intek>0)
					{
						dane->M = intek;
						dane->tab_A = (int*)malloc((dane->N*dane->M)*sizeof(int)); //alokacja pamieci
						dane->tab_B = (int*)malloc(dane->M*sizeof(int));
						dane->tab_C = (int*)malloc(dane->N*sizeof(int));
					}
					else
					{
						Err_(RGB(230, 0, 0), hwnd, "BD, Podaj liczbe ograniczen wieksza od zera!");
						PlaySound (("Media\\blad.wav"), NULL, SND_FILENAME | SND_ASYNC) ;
						fclose(plik); //zamkniecie pliku
						return 1;
					}
				}
				if((licznik>=3)&&((dane->N)>0)&&((dane->M)>0)&&(licznik<=2+(dane->N))) //wczytujemy tablice C - kolejno cyfry z pliku, 
				{										//zaczynajac od cyfry 3-ciej a konczac na cyfrze
					dane->tab_C[i] = intek;				//2+(dane->N). Ponizej podobnie.
					i++;
					if(licznik==((dane->N)+2))
						i = 0;
				}

				if((licznik>(2+(dane->N)))&&((dane->N)>0)&&((dane->M)>0)&&(licznik<=(((dane->M)*(dane->N))+2+(dane->N)+(dane->M)))) //wczytujemy tablice A
				{
					if((licznik-2-(dane->N)) % ((dane->N)+1) == 0) //wyluskuje dane do tablicy B
					{
						dane->tab_B[j] = intek;
						j++;
					}
					else
					{
						dane->tab_A[i] = intek; //zapisanie danych do tablicy jednowymiarowej
						i++;
					}
					if(licznik==((dane->M)*(dane->N)+(dane->N)+(dane->M)+2))
						i = 0;
				}

			licznik++;
			}
			if(znak == 45&&ujemna==0) //jesli jest minus, a minusa wczesniej nie bylo
				ujemna = 1;				
			if(ujemna==1&&znak<48&&znak>57&&znak!=45) //jesli wczesniej byl minus a teraz nie jest cyfra ani minus
				ujemna = 0;		
		}
	}

}while((znak != EOF)&&(znak != 30)); //czytanie znak po znaku zawartosci pliku
//KONIEC wczytywania danych z pliku
if((licznik-1)!=((dane->M)*(dane->N)+(dane->N)+(dane->M)+2))
{
	Err_(RGB(230, 0, 0), hwnd, "BD, Wyprowadzenie danych z pliku nie powiodlo sie!");
	PlaySound (("Media\\blad.wav"), NULL, SND_FILENAME | SND_ASYNC) ;

	BladOdczytu = 1;
}
else
{
	Err_(RGB(0, 0, 230), hwnd, "Wyprowadzenie danych z pliku powiodlo sie!");
	EnableWindow(GetDlgItem (hwnd, 4),TRUE);
	EnableWindow(GetDlgItem (hwnd, 6),TRUE);
	//rezerwuje pami dla wyniku
	dane->tab_X = (int*) malloc(dane->N * sizeof(int));

	BladOdczytu = 0;
}




fclose(plik); //zamkniecie pliku
return BladOdczytu;
}


const char* Zapis(const char *szFileName, PARAMETRY *dane)
{
char tmpbuf[128]; //tu przechowywujemy date i czas

int i = 0, j = 0, k = 0;

FILE *plik; //deklaracja zmiennej plikowej
plik = fopen(szFileName, "w+"); // otworzenie nowego pliku z prawami do zapisu i odczytu

fputs("Raport z analizy addytywnego algorytmu Balasa\n\n", plik);

fputs("Ilo zmiennych funkcji celu: \t", plik);
fprintf(plik, "%i\n", dane->N);

fputs("\nIlo funkcji ograniczajcych: \t", plik);
fprintf(plik, "%i\n", dane->M);

fputs("\nFunkcja celu: \t", plik);
	for(i=0; i<=((dane->N)-1);i++) //wypisanie tablicy w ilosci (dane->N)-1 (bo i zaczyna sie od 0)
	{
		fprintf(plik, "%ix%i ", dane->tab_C[i], i+1); //wypisanie tablicy C
		if((dane->tab_C[i+1])>=0&&((i+1) % (dane->N))!= 0) //wypisanie plusa tylko jezeli 
			fputs("+ ", plik);									//nastepna cyfra jest > 0
	}


fputs("\n\nWarunki:\n", plik);
	for(i=0; i<=((dane->M*dane->N)-1);i++)
	{
		fprintf(plik, "%ix%i ", dane->tab_A[i], (i%(dane->N))+1); //wypisanie tablicy A

		if((dane->tab_A[i+1])>=0&&((i+1) % (dane->N))!= 0) //wypisanie plusa tylko jezeli 
			fputs("+ ", plik);									//nastepna cyfra jest > 0


		if((i+1) % (dane->N)== 0)
		{
			fputs(" <= ", plik);
			fprintf(plik, "%i\n", dane->tab_B[j]);
			j++;
		}
	
	}
fprintf(plik, "\n%c", 30); //zapisanie znaczka po ktorym rozpoznajemy ze jest to koniec danych poczatkowych a poczatek wynikow
fputs("\nWyniki:\n", plik);

fprintf(plik, "%s\t", "Czy znaleziono rozwizanie:");

if((dane->EXIST)==TRUE)
{
	fputs("TAK!\r\n", plik);
	fputs("Wektor optymalnego rozwizania: [", plik);
	
	for(i=0; i<=((dane->N)-1);i++) //wypisanie tablicy w ilosci (dane->N)-1 (bo i zaczyna sie od 0)
	{
		fprintf(plik, " %i ", dane->tab_X[i]); //wypisanie tablicy wynikowej X
	}
	fputs("]\r\n\n", plik);

	fprintf(plik, "%s\t%i\r\n\n", "Optymalna warto funkcji celu:", dane->FVAL);
	fprintf(plik, "%s\r\n", "Sprawdzenie wynikw");
	for(j = 0; j<=((dane->M)-1);j++) //mamy j wierszy
	{
		for(i = 0; i<=((dane->N)-1);i++) //mamy i kolumn
		{
			k = k + (dane->tab_A[(j*(dane->N))+i])*(dane->tab_X[i]);
		}
	fprintf(plik, "%i%s%i\r\n",k,"<=",(dane->tab_B[j]));
	k=0;
	}
}
else
{
	fprintf(plik, "%s\r\n", "NIE!");
}


fputs("\n\nGodzina: ", plik);
fputs (_strtime( tmpbuf ), plik); //zapisanie dokadnego czasu
fputs("\t\tData: ", plik);
fputs (_strdate( tmpbuf ), plik); //zapisanie daty

fclose(plik); //zamknicie pliku
return szFileName;
}